
/**
 * Write a description of interface AnalogView here.
 *
 * @author Badral
 * @version 2012-04-03
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AnalogView extends JFrame implements Timeobserver {
    //Constants

    private static final boolean COLORFUL = true; //Paneliin ungutei eseh
    private Scene scene;
    private Clock clock;

    /**
     * Constructor
     */
    public AnalogView(Clock clock) {
        this.clock = clock;
        createWindow();
    }

    /**
     * Create Window
     */
    private void createWindow() {
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setBounds(250, 50, 150, 500);
        setTitle("Analog clock");
        Container C = getContentPane();

        //mainP
        JPanel mainP = new JPanel();
        mainP.setLayout(new BoxLayout(mainP, BoxLayout.PAGE_AXIS));
        mainP.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        if (COLORFUL) {
            mainP.setBackground(new Color(255, 220, 220));
        }
        C.add(mainP);
        //Thohiroh paneluud uusev.
        mainP.add(analogPcreate());

        pack();
        setVisible(true);
    }

    /**
     * Das analogP analog hugatsaag aguulna.
     */
    private Container analogPcreate() {
        JPanel analogP = new JPanel();
        analogP.setLayout(new BorderLayout());
        analogP.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));

        //Tsagiin label
        JLabel zeitL = new JLabel("Analog clock:");
        zeitL.setHorizontalAlignment(JTextField.CENTER);
        analogP.add(zeitL, BorderLayout.NORTH);

        scene = new Scene();

        scene.getClock(clock);
        analogP.add(scene, BorderLayout.CENTER);

        if (COLORFUL) {
            analogP.setBackground(new Color(221, 105, 250));
        }
        return analogP;
    }

    /**
     * ================ Busad chuhal methoduud ==============
     */
    public void retrieveTime() {
        drawClock();
    }

    /**
     * Scene-iig zaagchiin hamt zurna.
     */
    public void drawClock() {
        scene.getClock(clock);
        scene.repaint();
    }
}