
/**
 * Write a description of interface ControlView here.
 *
 * @author Badral
 * @version 2012-04-03
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class ControlView extends JFrame {
    //Constants

    private static final boolean COLORFUL = true; //colored panel
    private Controller controller;

    /**
     * Constructor
     */
    public ControlView(Controller controller) {
        this.controller = controller;
        createWindow();
    }

    /**
     * Create Window.
     */
    private void createWindow() {
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setBounds(50, 50, 200, 500);
        setTitle("Controller");
        Container C = getContentPane();

        //mainP
        JPanel mainP = new JPanel();
        mainP.setLayout(new BoxLayout(mainP, BoxLayout.PAGE_AXIS));
        mainP.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        if (COLORFUL) {
            mainP.setBackground(new Color(224, 27, 106));
        }
        C.add(mainP);

        //according Panels will be generated
        mainP.add(radioPCreate());
        mainP.add(buttonPCreate());

        pack();
        setVisible(true);
    }

    /**
     * radioP contains Radio buttons for choose.
     */
    private Container radioPCreate() {
        JRadioButton rb; //more Radiobuttons

        JPanel auswahlP = new JPanel();
        auswahlP.setLayout(new GridLayout(0, 1));
        auswahlP.setBorder(BorderFactory.createCompoundBorder(
        BorderFactory.createTitledBorder("Clock style selector"),
        BorderFactory.createEmptyBorder(10, 10, 10, 10)));
        //Button group
        ButtonGroup auswahlBG = new ButtonGroup();
        //digital
        rb = new JRadioButton("Digital", true);
        rb.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                digitalAction();
            }
        });
        auswahlBG.add(rb);
        auswahlP.add(rb);
        //analog
        rb = new JRadioButton("Analog");
        rb.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                analogAction();
            }
        });
        auswahlBG.add(rb);
        auswahlP.add(rb);

        if (COLORFUL) {
            auswahlP.setBackground(new Color(221, 105, 250));
        }
        return auswahlP;
    }

    /**
     * buttonP gets services of Buttons.
     */
    private Container buttonPCreate() {
        JButton button; //more buttons

        JPanel buttonP = new JPanel();
        buttonP.setLayout(new GridLayout(0, 1, 5, 5));
        buttonP.setBorder(BorderFactory.createCompoundBorder(
                BorderFactory.createTitledBorder("Control"),
                BorderFactory.createEmptyBorder(10, 10, 10, 10)));
        //start
        button = new JButton("start");
        button.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                startAction();
            }
        });
        buttonP.add(button);
        //stopp
        button = new JButton("stop");
        button.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                stoppAction();
            }
        });
        buttonP.add(button);
        //beenden
        button = new JButton("end");
        button.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent evt) {
                beendenAction();
            }
        });
        buttonP.add(button);

        if (COLORFUL) {
            buttonP.setBackground(new Color(219, 217, 218));
        }
        return buttonP;
    }

    /**
     * ======================== Actions-Methods ==========================
     */
    /**
     * open digitalView and close AnalogView.
     */
    private void digitalAction() {
        controller.openDigitalView();
        controller.closeAnalogView();
    }

    /**
     * open analogView and close DigitalView.
     */
    private void analogAction() {
        controller.openAnalogView();
        controller.closeDigitalView();
    }

    /**
     * React Mouseclick on Button start.
     */
    private void startAction() {
        controller.start();
    }

    /**
     * React Mouseclick on Button stop.
     */
    private void stoppAction() {
        controller.stopp();
    }

    /**
     * React Mouseclick on Button end.
     */
    private void beendenAction() {
        System.exit(0);
    }
}
