
public class Controller {

    Clock clock;
    Takter timer;
    ControlView controlView;
    DigitalView digitalView = null;
    AnalogView analogView = null;

    public Controller(Takter timer, Clock clock) {
        this.timer = timer;
        this.clock = clock;
        controlView = new ControlView(this);
    }

    public void start() {
        timer.start();
    }

    public void stopp() {
        timer.stop();
    }

    public void openAnalogView() {
        analogView = new AnalogView(clock);
        clock.registerObserver(analogView);
    }

    public void closeDigitalView() {
        if (digitalView != null) {
            digitalView.setVisible(false);
            clock.removeObserver(digitalView);
            digitalView.dispose();
        }

    }

    public void openDigitalView() {
        digitalView = new DigitalView(clock);
        clock.registerObserver(digitalView);
    }

    public void closeAnalogView() {
        if (analogView != null) {
            analogView.setVisible(false);
            clock.removeObserver(analogView);
            analogView.dispose();
        }

    }
}