
/**
 * Write a description of interface AnalogView here.
 *
 * @author Badral
 * @version 2012-04-03
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DigitalView extends JFrame implements Timeobserver {
    //Constants

    private static final boolean FARBIG = true; //farbige Anzeige der Panels
    private Clock clock;
    //Frame field
    private JTextField zeitTF;

    /**
     * Constructor
     */
    public DigitalView(Clock clock) {
        this.clock = clock;
        createWindow();
    }

    /**
     * Create Window.
     */
    private void createWindow() {
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setBounds(450, 50, 150, 320);
        setTitle("Digital view");
        Container C = getContentPane();

        //mainP
        JPanel mainP = new JPanel();
        mainP.setLayout(new BoxLayout(mainP, BoxLayout.PAGE_AXIS));
        mainP.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        if (FARBIG) {
            mainP.setBackground(new Color(255, 220, 220));
        }
        C.add(mainP);
        //Entsprechende Panels werden erstellt.
        mainP.add(digitalPCreate());

        pack();
        setVisible(true);
    }

    /**
     * digitalP digital tsagiig aguulna.
     */
    private Container digitalPCreate() {
        JPanel digitalP = new JPanel();
        digitalP.setLayout(new GridLayout(0, 1));
        digitalP.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
        //Lokales Label fuer die Zeit
        JLabel zeitL = new JLabel("digital clock:");
        zeitL.setHorizontalAlignment(JTextField.CENTER);
        digitalP.add(zeitL);
        //Globales Textfeld fuer die Zeitanzeige
        zeitTF = new JTextField("00 : 00");
        zeitTF.setFont(new Font("Sansserif", Font.BOLD, 24));
        zeitTF.setHorizontalAlignment(JTextField.CENTER);
        zeitTF.setEditable(false);
        digitalP.add(zeitTF);

        if (FARBIG) {
            digitalP.setBackground(new Color(221, 105, 250));
        }
        return digitalP;
    }

    /**
     * ================ Busad chuhal methoduud ==============
     */
    public void retrieveTime() {
        String dt = createDtime();
        zeitTF.setText(dt);
    }

    /**
     * Get time and adjust
     *
     * @param return Digital view-iin string.
     */
    private String createDtime() {
        String hour, minut;
        int stunde = clock.getStunde();
        if (stunde < 10) {
            hour = "0" + stunde;
        } else {
            hour = "" + stunde;
        }
        int minute = clock.getMinute();
        if (minute < 10) {
            minut = "0" + minute;
        } else {
            minut = "" + minute;
        }
        return hour + " : " + minut;
    }
}